=== include/CMakeLists.txt ===
add_subdirectory(sdsl)
