=== extras/cheatsheet/Makefile ===

sdsl-cheatsheet.pdf: sdsl-cheatsheet.tex
	pdflatex sdsl-cheatsheet.tex

clean:
	rm -f sdsl-cheatsheet.pdf \
          sdsl-cheatsheet.aux
