=== debian/changelog ===
libsdsl (2.1.1+dfsg-6) unstable; urgency=medium

  * Team upload.
  * typo_caught_by_gcc15.patch: new: fix build failure. (Closes: #1097267)
  * cmake-4.patch: new: bump cmake requirement to 3.10. (Closes: #1113197)
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/watch: convert to v5 Github template.
  * use_debian_packaged_d3.patch: normalize Last-Update.

 -- Étienne Mollier <emollier@debian.org>  Mon, 06 Oct 2025 20:35:05 +0200

libsdsl (2.1.1+dfsg-5) unstable; urgency=medium

  * Team upload.
  * d/control: allow any 64-bit architecture + x32. Closes: #1057248
  * d/clean: two files added to the removal list. Closes: #1045726

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 31 Jul 2024 17:33:30 +0200

libsdsl (2.1.1+dfsg-4) unstable; urgency=medium

  * Team upload.

  [ Manuel A. Fernandez Montecelo ]
  * Add support for riscv64 arch. Closes: #1023768

  [ Michael R. Crusoe ]
  * debian/patches/use_debian_packaged_d3.patch doesn't need forwarding
    upstream
  * Standards-Version: 4.6.2 (routine-update)
  * Set upstream metadata fields: Repository.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 09 Aug 2023 16:55:15 +0200

libsdsl (2.1.1+dfsg-3) unstable; urgency=medium

  * Fic watch file
  * Standards-Version: 4.6.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Fix Maintainer name of Debian Science team (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Wed, 07 Dec 2022 07:32:46 +0100

libsdsl (2.1.1+dfsg-2) unstable; urgency=medium

  * Refresh packaging (debhelper 12, std-ver 4.3.0)

 -- Tomasz Buchert <tomasz@debian.org>  Thu, 10 Jan 2019 00:51:44 +0100

libsdsl (2.1.1+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Exclude libdivsufsort from upstream source
  * Use d-shlibs
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * hardening=+all

 -- Andreas Tille <tille@debian.org>  Mon, 24 Sep 2018 20:55:00 +0200
