=== debian/control ===
Source: libsdsl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Tomasz Buchert <tomasz@debian.org>,
           Andreas Tille <tille@debian.org>
Section: libs
Priority: optional
Build-Depends: architecture-is-64-bit [!x32],
               cmake,
               d-shlibs,
               debhelper-compat (= 13),
               libdivsufsort-dev,
               libjs-d3
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/libsdsl
Vcs-Git: https://salsa.debian.org/science-team/libsdsl.git
Homepage: https://github.com/simongog/sdsl-lite

Package: libsdsl-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdivsufsort-dev,
         libsdsl3 (= ${binary:Version}),
         ${misc:Depends}
Description: succinct data structure library - development files
 The Succinct Data Structure Library (SDSL) is a powerful and flexible
 C++11 library implementing succinct data structures. In total, the
 library contains the highlights of 40 research publications. Succinct
 data structures can represent an object (such as a bitvector or a
 tree) in space close the information-theoretic lower bound of the
 object while supporting operations of the original object
 efficiently. The theoretical time complexity of an operations
 performed on the classical data structure and the equivalent succinct
 data structure are (most of the time) identical.
 .
 This package installs development files.

Package: libsdsl3
Architecture: any
Multi-Arch: same
Depends: libjs-d3,
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: succinct data structure library
 The Succinct Data Structure Library (SDSL) is a powerful and flexible
 C++11 library implementing succinct data structures. In total, the
 library contains the highlights of 40 research publications. Succinct
 data structures can represent an object (such as a bitvector or a
 tree) in space close the information-theoretic lower bound of the
 object while supporting operations of the original object
 efficiently. The theoretical time complexity of an operations
 performed on the classical data structure and the equivalent succinct
 data structure are (most of the time) identical.
 .
 This package installs static library.
