=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_install:
	dh_install
	cp -a `find . -name libsdsl_static.a` `echo $$(find debian/tmp/usr/lib -name libsdsl.so) | sed 's/\.so$$/.a/'`
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
                    --exclude-la \
		    --movedev debian/tmp/usr/include/* usr/include \
		    debian/tmp/usr/lib/*/*.so
