=== debian/watch ===
Version: 5

Template: Github
Owner: simongog
Project: sdsl-lite
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%
Dversionmangle: auto
Repacksuffix: +dfsg
